/*
 * Copyright (C) 2011-2021 Intel Corporation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in
 *     the documentation and/or other materials provided with the
 *     distribution.
 *   * Neither the name of Intel Corporation nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


#ifndef _CREATE_PARAM_H_
#define _CREATE_PARAM_H_

#include "metadata.h"
typedef struct _create_param_t
{
    uint64_t          enclave_size;
    uint64_t          stack_max_size;
    uint64_t          stack_min_size;
    uint64_t          stack_limit_addr;
    uint64_t          stack_base_addr;
    size_t            ssa_base_addr;
    uint64_t          heap_max_size;
    uint64_t          heap_min_size;
    uint64_t          rsrv_max_size;
    uint64_t          rsrv_min_size;
    uint64_t          heap_init_size;
    uint64_t          heap_offset;
    uint64_t          rsrv_init_size;
    uint64_t          rsrv_offset;
    uint64_t          rsrv_executable;
    uint64_t          edmm_bk_overhead;
    uint64_t          user_region_size;
    uint64_t          first_ssa_gpr;
    uint64_t          td_addr;
    uint64_t          tls_addr;
    uint32_t          tcs_num;
    uint32_t          tcs_max_num;
    uint32_t          tcs_min_pool;
    uint32_t          tcs_policy;
    uint32_t          xsave_size;
    uint32_t          ipp_fips_on;
    uint32_t          ossl_fips_on;
} create_param_t;

#endif
